## farbfeld 3

=== Makefile ===
# See LICENSE file for copyright and license details
# farbfeld - suckless image format with conversion tools
.POSIX:

include config.mk

REQ = util
HDR = arg.h
BIN = png2ff ff2png jpg2ff ff2jpg ff2pam ff2ppm
SCR = 2ff
MAN1 = 2ff.1 $(BIN:=.1)
MAN5 = farbfeld.5

png2ff-LDFLAGS = $(PNG-LDFLAGS)
ff2png-LDFLAGS = $(PNG-LDFLAGS)
jpg2ff-LDFLAGS = $(JPG-LDFLAGS)
ff2jpg-LDFLAGS = $(JPG-LDFLAGS)

all: $(BIN)

$(BIN): $(REQ:=.o)

$(BIN:=.o): config.mk $(HDR) $(REQ:=.h)

.o:
	$(CC) $(LDFLAGS) $($*-LDFLAGS) -o $@ $< $(REQ:=.o)

clean:
	rm -f $(BIN) $(BIN:=.o) $(REQ:=.o)

dist:
	rm -rf "farbfeld-$(VERSION)"
	mkdir -p "farbfeld-$(VERSION)"
	cp -R FORMAT LICENSE Makefile README config.mk $(SCR) \
	      $(HDR) $(BIN:=.c) $(REQ:=.c) $(REQ:=.h) \
	      $(MAN1) $(MAN5) "farbfeld-$(VERSION)"
	tar -cf - "farbfeld-$(VERSION)" | gzip -c > "farbfeld-$(VERSION).tar.gz"
	rm -rf "farbfeld-$(VERSION)"

install: all
	mkdir -p "$(DESTDIR)$(PREFIX)/bin"
	cp -f $(SCR) $(BIN) "$(DESTDIR)$(PREFIX)/bin"
	for f in $(BIN) $(SCR); do chmod 755 "$(DESTDIR)$(PREFIX)/bin/$$f"; done
	mkdir -p "$(DESTDIR)$(MANPREFIX)/man1"
	cp -f $(MAN1) "$(DESTDIR)$(MANPREFIX)/man1"
	for m in $(MAN1); do chmod 644 "$(DESTDIR)$(MANPREFIX)/man1/$$m"; done
	mkdir -p "$(DESTDIR)$(MANPREFIX)/man5"
	cp -f $(MAN5) "$(DESTDIR)$(MANPREFIX)/man5"
	for m in $(MAN5); do chmod 644 "$(DESTDIR)$(MANPREFIX)/man5/$$m"; done

uninstall:
	for f in $(BIN) $(SCR); do rm -f "$(DESTDIR)$(PREFIX)/bin/$$f"; done
	for m in $(MAN1); do rm -f "$(DESTDIR)$(MANPREFIX)/man1/$$m"; done
	for m in $(MAN5); do rm -f "$(DESTDIR)$(MANPREFIX)/man5/$$m"; done

=== debian/changelog ===
farbfeld (3-4) unstable; urgency=medium

  * Build-depend on libjpeg-dev instead of libjpeg-turbo8-dev
  * Set the maint LDFLAGS to -Wl,--no-as-needed

 -- Paride Legovini <pl@ninthfloor.org>  Tue, 22 Aug 2017 15:30:11 +0200

farbfeld (3-3) unstable; urgency=medium

  * Add missing references to debian/copyright
  * 2ff: fix the error message for missing `convert'
  * Install the FORMAT and README documentation files
  * Hardened build (hardening=+all)

 -- Paride Legovini <pl@ninthfloor.org>  Mon, 31 Jul 2017 14:49:34 +0200

farbfeld (3-2) unstable; urgency=medium

  * Try upload again after accidental reject

 -- Paride Legovini <pl@ninthfloor.org>  Wed, 19 Jul 2017 23:42:37 +0200

farbfeld (3-1) unstable; urgency=low

  * Initial release (Closes: #851185)
    Debianisation mostly due to Dmitry Bogatov.

 -- Paride Legovini <pl@ninthfloor.org>  Mon, 17 Jul 2017 08:36:22 +0200

=== debian/control ===
Source: farbfeld
Section: graphics
Priority: extra
Maintainer: Paride Legovini <pl@ninthfloor.org>
Uploaders: Dmitry Bogatov <KAction@gnu.org>
Build-Depends: debhelper (>=10), libjpeg-dev, libpng-dev
Standards-Version: 4.0.0
Homepage: http://tools.suckless.org/farbfeld
Vcs-Git: https://anonscm.debian.org/cgit/collab-maint/farbfeld.git/
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/farbfeld.git/

Package: farbfeld
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: imagemagick
Description: lossless image format designed to be parsed and piped easily
 Farbfeld is a lossless image format designed to be parsed and piped
 easily. It is designed to be as simple as possible, leaving the task
 of compression to outside tools, beating PNG's filesize in many
 cases.
 .
 This package contains tools for converting between farbfeld format
 and other image formats (png, jpeg, ppm, pam, gif).

=== debian/rules ===
#!/usr/bin/make -f

# https://wiki.debian.org/HardeningWalkthrough
export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Os -Wall -pedantic

# --as-needed breaks the build of the package, so let's turn it off
# explicitly. This is not needed in Debian, but the default may change.
# Ubuntu already defaults to --as-needed, so disabling it makes the
# package build there unmodified.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed

%:
	dh $@

=== debian/watch ===
version=3
http://dl.suckless.org/farbfeld/farbfeld-(\d).tar.gz

## farbfeld 4

=== Makefile ===
--- 
+++ 
@@ -11,19 +11,32 @@
 MAN1 = 2ff.1 $(BIN:=.1)
 MAN5 = farbfeld.5
 
-png2ff-LDFLAGS = $(PNG-LDFLAGS)
-ff2png-LDFLAGS = $(PNG-LDFLAGS)
-jpg2ff-LDFLAGS = $(JPG-LDFLAGS)
-ff2jpg-LDFLAGS = $(JPG-LDFLAGS)
-
 all: $(BIN)
 
-$(BIN): $(REQ:=.o)
+png2ff-LDLIBS = $(PNG-LDLIBS)
+ff2png-LDLIBS = $(PNG-LDLIBS)
+jpg2ff-LDLIBS = $(JPG-LDLIBS)
+ff2jpg-LDLIBS = $(JPG-LDLIBS)
 
-$(BIN:=.o): config.mk $(HDR) $(REQ:=.h)
+png2ff: png2ff.o $(REQ:=.o)
+ff2png: ff2png.o $(REQ:=.o)
+jpg2ff: jpg2ff.o $(REQ:=.o)
+ff2jpg: ff2jpg.o $(REQ:=.o)
+ff2pam: ff2pam.o $(REQ:=.o)
+ff2ppm: ff2ppm.o $(REQ:=.o)
+
+png2ff.o: png2ff.c config.mk $(HDR) $(REQ:=.h)
+ff2png.o: ff2png.c config.mk $(HDR) $(REQ:=.h)
+jpg2ff.o: jpg2ff.c config.mk $(HDR) $(REQ:=.h)
+ff2jpg.o: ff2jpg.c config.mk $(HDR) $(REQ:=.h)
+ff2pam.o: ff2pam.c config.mk $(HDR) $(REQ:=.h)
+ff2ppm.o: ff2ppm.c config.mk $(HDR) $(REQ:=.h)
 
 .o:
-	$(CC) $(LDFLAGS) $($*-LDFLAGS) -o $@ $< $(REQ:=.o)
+	$(CC) -o $@ $(LDFLAGS) $< $(REQ:=.o) $($*-LDLIBS)
+
+.c.o:
+	$(CC) -c $(CPPFLAGS) $(CFLAGS) $<
 
 clean:
 	rm -f $(BIN) $(BIN:=.o) $(REQ:=.o)

=== debian/changelog ===
farbfeld (4-2) unstable; urgency=medium

  * Change the package short description to match what upstream suggests
  * farbfeld 4 is entirely ISC licensed, d/copyright updated accordingly
  * Override PREFIX in d/rules instead of patching config.mk
  * Add an autopkgtest: roundtrip

 -- Paride Legovini <pl@ninthfloor.org>  Mon, 07 May 2018 15:41:49 +0000

farbfeld (4-1) unstable; urgency=medium

  * New upstream release.
  * Package now maintained within the PhotoTools team
  * Bump Standards-Version to 4.1.4 (no changes needed)
  * d/control: use secure URI in the Homepage field

 -- Paride Legovini <pl@ninthfloor.org>  Wed, 11 Apr 2018 14:50:20 +0000

farbfeld (3-5) unstable; urgency=medium

  * Packaging repository moved to salsa
  * The d/control Vcs- fields now point to the salsa repository
  * Use the standard Debian build flags when compiling
  * Bump Standards-Version to 4.1.3
    - Priority: extra replaced by Priority: optional
  * Bump compat level to 11, build-depend on debhelper >= 11~
  * Added upstream metadata file (d/upstream/metadata)
  * d/watch: use https URI and version=4 (no additional changes required)
  * d/changelog: use https URIs, update copyright years

 -- Paride Legovini <pl@ninthfloor.org>  Sat, 24 Feb 2018 12:49:33 +0000

=== debian/control ===
Source: farbfeld
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Paride Legovini <pl@ninthfloor.org>,
 Dmitry Bogatov <KAction@gnu.org>
Build-Depends: debhelper (>=11~), libjpeg-dev, libpng-dev
Standards-Version: 4.1.4
Homepage: https://tools.suckless.org/farbfeld
Vcs-Git: https://salsa.debian.org/debian-phototools-team/farbfeld.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/farbfeld

Package: farbfeld
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: imagemagick
Description: Lossless image format which is easy to parse, pipe and compress
 Farbfeld is a lossless image format designed to be parsed and piped
 easily. It is designed to be as simple as possible, leaving the task
 of compression to outside tools, beating PNG's filesize in many
 cases.
 .
 This package contains tools for converting between farbfeld format
 and other image formats (png, jpeg, ppm, pam, gif).

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 # https://wiki.debian.org/HardeningWalkthrough
 export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
-export DEB_CFLAGS_MAINT_APPEND  = -Os -Wall -pedantic
+#export DEB_CFLAGS_MAINT_APPEND  = -Os -Wall -pedantic
 
 # --as-needed breaks the build of the package, so let's turn it off
 # explicitly. This is not needed in Debian, but the default may change.
@@ -12,3 +12,6 @@
 
 %:
 	dh $@
+
+override_dh_auto_install:
+	dh_auto_install -- PREFIX=/usr

=== debian/tests/control ===
Tests: roundtrip
Depends: @, imagemagick

=== debian/watch ===
version=4
https://dl.suckless.org/farbfeld/farbfeld-(\d).tar.gz
